package com.myoa.engineering.music.soundhoundfound.receiver.handler.message.text;

import org.springframework.stereotype.Component;
import org.telegram.telegrambots.meta.api.objects.Message;

import com.myoa.engineering.music.soundhoundfound.receiver.handler.message.TextMessageHandler;

import lombok.extern.slf4j.Slf4j;

/**
 * AddCommandHandler
 * @author Shin Woo-jin (woo-jin.shin@linecorp.com)
 * @since 2021-08-21
 *
 */
@Slf4j
@Component
public class AddCommandHandler implements TextMessageHandler {

    @Override
    public boolean isApplicable(Message message) {
        return TextMessageHandler.super.isApplicable(message) && message.getText().startsWith("/add");
    }

    @Override
    public void handle(Message message) {
        log.info("AddCommandHandler : {}", message.getText());
    }
}
